#!/usr/bin/perl

my %connection = ();

#input parameters
$file=$ARGV[0];

if ($ARGV[1]) {$XFIGname=$ARGV[1];} else {$XFIGname=SAVE}
if ($ARGV[2]) {$nographic=$ARGV[2];} else {$nographic=0}
if ($ARGV[3]) {$portrait=$ARGV[3];} else {$portrait=0}

$scale=1;
$entry=0;
$run=0;
$maxvalconnection=0;
$minvalconnection=0;
$maximumset=0;
$minstep=1;
open (FILE, $file) || die "cannot open file $file";
#here the coordinates can be specified default landscape
$XMAX=0;
$YMAX=0;
$XMIN=10000;
$YMIN=10000;

if ($ARGV[6] && $ARGV[7] && $ARGV[4] && $ARGV[5]) {
  $XMAX=$ARGV[6];$YMAX=$ARGV[7];$XMIN=$ARGV[4];$YMIN=$ARGV[5];$maximumset=1;
}

print "##################################################\n";
print "# ViTAN - Visualisation tool for ad hoc networks #\n";
print "#                                                #\n";
print "# verison 1.1     -      acticom mobile networks #\n";
print "##################################################\n";


while (<FILE>) {
  chomp;
  @elements = split;
  push @table, [ @elements ];
  if ($portrait) {
    $xkor{$entry}=int($table[$entry][1]);
    $ykor{$entry}=int($table[$entry][0]);
  }
  else {
    $xkor{$entry}=int($table[$entry][0]);
    $ykor{$entry}=int($table[$entry][1]);
  }
  if ($maximumset==0) {
    if (int($xkor{$entry}) > $XMAX) {$XMAX=int($xkor{$entry});}
    if (int($ykor{$entry}) > $YMAX) {$YMAX=int($ykor{$entry});}
    if (int($xkor{$entry}) < $XMIN) {$XMIN=int($xkor{$entry});}
    if (int($ykor{$entry}) < $YMIN) {$YMIN=int($ykor{$entry});}
  }
  print "$xkor{$entry} $ykor{$entry} ";
  $name{$entry}=$table[$entry][2];
  if ($xkor{$entry}<=$XMAX && $ykor{$entry}<=$YMAX && $xkor{$entry}>=$XMIN && $ykor{$entry}>=$YMIN) {
    $radius{$entry}=$table[$entry][3];
    $terminalpresentation{$entry}=$table[$entry][4];
    print "$name{$entry} $radius{$entry} $terminalpresentation{$entry} ";
      for ($terminals=0;$terminals<=$#{$table[0]}-5;$terminals+=1) {
	$help=$terminals+5;
	$connection{$entry}{$terminals}=int($table[$entry][$help]);
	print "$connection{$entry}{$terminals} ";
	if ($connection{$entry}{$terminals}>$maxvalconnection) {$maxvalconnection=$connection{$entry}{$terminals};}
	if ($connection{$entry}{$terminals}<$minvalconnection) {$minvalconnection=$connection{$entry}{$terminals};}
      }
    print "\n";
    $inboundingbox{$entry}=1;
  }
  else {
    print "$name{$entry} is not in the bounding box!\n";
    $inboundingbox{$entry}=0;
    $run++;
  }
  $entry++;
}
$display=$entry-$run;
print "$entry WTs are in the list and $display WTs are depicted\n";
close(FILE);


#scaling
$scaling=1;
if ($scale) {
  if (($XMAX-$XMIN)<12000 && ($YMAX-$YMIN)<8000) {
    while (($XMAX-$XMIN)<12000 && ($YMAX-$YMIN)<8000) {
      print "Scaling up!\n";
      for ($WT=0;$WT<$entry;$WT++) {
	if ($inboundingbox{$WT}) {
	  $xkor{$WT}=$xkor{$WT}*2;
	  $ykor{$WT}=$ykor{$WT}*2;
	  $radius{$WT}=$radius{$WT}*2;
	}
      }
      $scaling=$scaling*2;
      $XMAX=$XMAX*2;$XMIN=$XMIN*2;$YMAX=$YMAX*2;$YMIN=$YMIN*2;
    }
  }
  if (($XMAX-$XMIN)>24000 && ($YMAX-$YMIN)>16000) {
    while (($XMAX-$XMIN)>24000 && ($YMAX-$YMIN)>16000) {
      print "Scaling down!\n";
      for ($WT=0;$WT<$entry;$WT++) {
	if ($inboundingbox{$WT}) {
	  $xkor{$WT}=$xkor{$WT}/2;
	  $ykor{$WT}=$ykor{$WT}/2;
	  $radius{$WT}=$radius{$WT}/2;
	}
      }
      $scaling=$scaling/2;
      $XMAX=$XMAX/2;$XMIN=$XMIN/2;$YMAX=$YMAX/2;$YMIN=$YMIN/2;
    }
  }
}

if ($maximumset==0) {
  $yoffset=int(($YMAX-$YMIN)/20);;
  $xoffset=int(($XMAX-$XMIN)/20);;
  $XMAX= int($XMAX+$xoffset);
  $YMAX= int($YMAX+$yoffset);
  $XMIN= int($XMIN-$xoffset);
  $YMIN= int($YMIN-$yoffset);
}



if ($portrait) {print "picture format: $XMAX $YMAX (portrait)\n";}
else {print "picture format: $XMIN $YMIN $XMAX $YMAX (landscape)\n";}
if ($nographic) {print "no pictures used to represent wireless nodes\n";} 
else { print "using picture to represent wireless nodes\n";}

#deleting connection of non displayed WTs
for ($WT=0;$WT<$entry;$WT++) {
  for ($actWT=0;$actWT<$entry;$actWT++) {
    if ($inboundingbox{$actWT}==0) {
      $connection{$WT}{$actWT}=0;
      $connection{$actWT}{$WT}=0;
    }
  }
}

#generating the XFIG file
open (XFIGFILE, ">".$XFIGname.".fig") || die "cannot open result file";
print XFIGFILE"#FIG 3.2\n";
if ($portrait) {
  print XFIGFILE"Portrait\n";
}
else {
  print XFIGFILE"Landscape\n";
}
print XFIGFILE"Center\n";
print XFIGFILE"Metric\n";
print XFIGFILE"A4\n";
print XFIGFILE"100.00\n";
print XFIGFILE"Single\n";
print XFIGFILE"-2\n";
print XFIGFILE"1200 2\n";

print "generating extra colors for XFIG tool\n";
@hexdigit =('F','E','D','C','B','A','9','8','7','6','5','4','3','2','1','0');
for ($colorcounter=0;$colorcounter<=$maxvalconnection;$colorcounter+=$minstep) {
  $value=40+$colorcounter;
  $factor=int(255/$maxvalconnection);
  $first=int($colorcounter*$factor/16);
  $second=int(($colorcounter*$factor-$first)/16);
  $color{$colorcounter}=$value;
  print "$value #$hexdigit[$first]$hexdigit[$second]$hexdigit[$first]$hexdigit[$second]$hexdigit[$first]$hexdigit[$second]\n";
  print XFIGFILE"0 $value #$hexdigit[$first]$hexdigit[$second]$hexdigit[$first]$hexdigit[$second]$hexdigit[$first]$hexdigit[$second]\n";
}

#bounding box
print XFIGFILE"2 2 0 3 0 7 800 0 -1 0.000 0 0 -1 0 0 5\n";
print XFIGFILE"$XMIN $YMIN $XMAX $YMIN $XMAX $YMAX $XMIN $YMAX $XMIN $YMIN\n";
$step=int(($YMAX-$YMIN)/20);
for ($h=$YMIN;$h<=$YMAX;$h+=$step) {
  print XFIGFILE"2 1 0 1 0 7 800 0 -1 0.000 0 0 -1 0 0 2\n";
  $help=$XMIN+100;
  print XFIGFILE"$XMIN $h $help $h\n";
  $meter=int($h/($scaling));
  if ($scaling>=1) {$help=$XMIN-250;} else {$help=$XMIN-500}
  print XFIGFILE"4 1 0 800 0 0 12 0.0000 4 1350 0 $help $h $meter\\001\n";
  print XFIGFILE"2 1 0 1 0 7 800 0 -1 0.000 0 0 -1 0 0 2\n";
  $help=$XMAX-100;
  print XFIGFILE"$help $h $XMAX $h\n";
}
$step=int(($XMAX-$XMIN)/20);
for ($h=$XMIN;$h<=$XMAX;$h+=$step) {
  print XFIGFILE"2 1 0 1 0 7 800 0 -1 0.000 0 0 -1 0 0 2\n";
  $help=$YMIN+100;
  print XFIGFILE"$h $YMIN $h $help\n";
  $meter=int($h/($scaling));
  $help=$YMIN-150;
  print XFIGFILE"4 1 0 800 0 0 12 0.0000 4 1350 0 $h $help $meter\\001\n";
  print XFIGFILE"2 1 0 1 0 7 800 0 -1 0.000 0 0 -1 0 0 2\n";
  $help=$YMAX-100;
  print XFIGFILE"$h $help $h $YMAX\n";
}
print XFIGFILE "4 1 0 800 0 0 12 0.0000 4 1350 0 ".($XMAX-1250)." ".($YMAX+250)."  Scaling factor: $scaling\\001\n";

#placing the nodes and coverage
for ($h=0;$h<$entry;$h++) {
  if ($inboundingbox{$h}) {
    if ($nographic) {
      $xlength=int(($XMAX-$XMIN)/80);
      $ylength=int(($XMAX-$XMIN)/80);
      print XFIGFILE"1 4 0 3 4 4 700 0 20 0.000 1 0.0000 $xkor{$h} $ykor{$h} $xlength $ylength 0 0 0 0\n";
    }
    else {
      $xlength=int(($XMAX-$XMIN)/20);
      $ylength=int(($YMAX-$YMIN)/15);
      print XFIGFILE"2 5 0 1 0 -1 700 0 -1 0.000 0 0 -1 0 0 5\n";
      print XFIGFILE"  0 terminalpics/$terminalpresentation{$h}.gif\n";
      #some more quick hack
      $x1=$xkor{$h}-int($xlength/2);
      $y1=$ykor{$h}-int($ylength/2);
      $x2=$x1+$xlength;
      $y2=$y1;
      $x3=$x2;
      $y3=$y2+$ylength;
      $x4=$x1;
      $y4=$y3;
      $x5=$x1;
      $y5=$y1;
      print XFIGFILE"  $x1 $y1 $x2 $y2 $x3 $y3 $x4 $y4 $x5 $y5\n";
    }
    print XFIGFILE"1 4 0 3 11 11 900 0 20 0.000 1 0.0000 $xkor{$h} $ykor{$h} ".int($radius{$h})." ".int($radius{$h})." 0 0 0 0\n";
  }
}

#drawing the connections
for ($WT=0;$WT<$entry;$WT++) {
  if ($nographic) {
    $help=$ykor{$WT}+450;
  }
  else {
    $help=$ykor{$WT}+650;
  }
  for ($actWT=0;$actWT<$entry;$actWT++) {
    if ($actWT!=$WT) {
      $width=int(8*$connection{$WT}{$actWT}/$maxvalconnection);
      if ($width<1) {$width=1};
      if ($width<1) {$width=1;}
      if ($width>8) {$width=8;}
      if ($connection{$WT}{$actWT}) {
	print XFIGFILE"4 1 0 701 0 0 12 0.0000 4 1350 0 $xkor{$WT} $help $name{$WT}\\001\n";
	print "$name{$WT} is in the range of $name{$actWT} receiving with quality level $connection{$WT}{$actWT}\n";
	$depth=$connection{$WT}{$actWT};
	$arrowdepth=600+$depth;
	$arrow1=20*$width;
	if ($arrow1<30) {$arrow1=30;}
	if ($arrow1<100) {$arrow1=100;}
	$arrow2=$arrow1;
	print XFIGFILE"2 1 0 $width $color{$connection{$WT}{$actWT}} 7 $arrowdepth 0 -1 0.000 0 0 -1 0 1 2\n1 1 $width.00 $arrow1.00 $arrow2.00\n";
	$helpendpointx= int($xkor{$actWT} + 0.5*($xkor{$WT}-$xkor{$actWT}));
	$helpendpointy= int($ykor{$actWT} + 0.5*($ykor{$WT}-$ykor{$actWT}));
	$helpendpointx2= int($xkor{$actWT} + 0.95*($xkor{$WT}-$xkor{$actWT}));
	$helpendpointy2= int($ykor{$actWT} + 0.95*($ykor{$WT}-$ykor{$actWT}));
	print XFIGFILE"$xkor{$WT} $ykor{$WT} $helpendpointx $helpendpointy \n";
	$helpendpointx= int($xkor{$WT} + 0.25*($xkor{$actWT}-$xkor{$WT}));
	$helpendpointy= int($ykor{$WT} + 0.25*($ykor{$actWT}-$ykor{$WT}));
	print XFIGFILE"1 3 0 3 $color{$connection{$WT}{$actWT}} $color{$connection{$WT}{$actWT}} $depth 0 20 0.000 1 0.0000 $helpendpointx $helpendpointy 100 100 0 0 0 0\n";
	$helpendpointx= int($xkor{$WT} + 0.25*($xkor{$actWT}-$xkor{$WT}));
	$helpendpointy= int($ykor{$WT} + 0.25*($ykor{$actWT}-$ykor{$WT}))+50;
	$simplecolor=0;
	if ($connection{$WT}{$actWT}>int($maxvalconnection/2)) {$simplecolor=7;}
	print XFIGFILE"4 1 $simplecolor $depth 0 2 12 0.0000 4 1350 0 $helpendpointx $helpendpointy $connection{$WT}{$actWT}\\001\n";
      }
    }
  }
}
close(FrameFILE);
print"ViTAN has finished.\n";
